﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Printing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace BarCodes
{
    public partial class BarCodes : Form
    {
        public BarCodes()
        {
            InitializeComponent();
        }

        private void bPrint_Click(object sender, EventArgs e)
        {
            if (string.IsNullOrEmpty(txtBarCode.Text))
            {
                MessageBox.Show("Empty Bar Code String");
            }
            PrintDialog dlg = new PrintDialog();
            if (dlg.ShowDialog() == DialogResult.OK)
            {
                PrinterSettings ps = dlg.PrinterSettings;
                PrintDocument doc = new PrintDocument();
                doc.PrinterSettings = ps;
                doc.PrintPage += new PrintPageEventHandler(printBarCodes);
                doc.Print();
            }
        }

        private void printBarCodes(object obj, PrintPageEventArgs ev)
        {
            ev.Graphics.PageUnit = GraphicsUnit.Millimeter;
            Font c39 = new Font("Free 3 of 9 Extended", 10f, GraphicsUnit.Millimeter);
            Font c128 = new Font("Code 128", 15f, GraphicsUnit.Millimeter);
            Font ean13 = new Font("Code EAN13", 25f, GraphicsUnit.Millimeter);
            Font I29 = new Font("MW6 IT25M", 25f, GraphicsUnit.Millimeter);
            Font ttl = new Font("Arial", 12f, FontStyle.Bold, GraphicsUnit.Millimeter);
            Font ttlf = new Font("Arial", 10f, GraphicsUnit.Millimeter);

            string barcode;
            ev.Graphics.DrawString("Bar Codes for " + txtBarCode.Text, ttl, Brushes.Black, 10f, 10f);

            try
            {
                barcode = CBEncoder.CodifyEAN13(txtBarCode.Text);
                ev.Graphics.DrawString("EAN 13", ttlf, Brushes.Black, 10f, 30f);
                ev.Graphics.DrawString(barcode, ean13, Brushes.Black, 20f, 50f);
            }
            catch
            {
                ev.Graphics.DrawString("EAN 13 not valid", ttlf, Brushes.Black, 10f, 30f);
            }

            barcode = CBEncoder.CodifyCode39(txtBarCode.Text);
            ev.Graphics.DrawString("Code 39", ttlf, Brushes.Black, 10f, 90f);
            ev.Graphics.DrawString(barcode, c39, Brushes.Black, 20f, 110f);

            barcode = CBEncoder.CodifyCode128(txtBarCode.Text);
            ev.Graphics.DrawString("Code 128", ttlf, Brushes.Black, 10f, 130f);
            ev.Graphics.DrawString(barcode, c128, Brushes.Black, 20f, 150f);

            ev.HasMorePages = false;
        }
    }
}
